function [INP_IMG,Projs,OUT]=radon_invradon_demo_CRC;

% Demo of Radon Transform using 3 pass rotation 
% and Inverse Radon using Ramp-filtered back projection
% Copyright L. Yaroslavsky (yaro@eng.tau.ac.il)
% Last modified July 20, 2011; Modified June, 20, 2011, from revious version: Aug. 20, 2008,Tampere, Finland.  
% [INP_IMG,Projs,OUT]=radon_invradon_demo_CRC(INP_IMG);
   
figure_n(4);
load FastRadonTransTestImg;
INP_IMG=FastRadonTransTestImg;
% ---------------------------RADON TRANSFORM----------------------------------

Phi_min=-90;
Phi_max=90;

Sz=size(INP_IMG,1);
Crcl=ringg(Sz,fix(Sz/2),fix(Sz/2),fix(0.7*Sz/2),0);
INP_IMG=INP_IMG.*Crcl;
Nphi=Sz;
Projs=[];
Angle=[];
a_step=(Phi_max-Phi_min)/Nphi;

INP_rot=fastrotate(INP_IMG,Phi_min);
for P=1:Nphi,
   phi=Phi_min+(P-1)*(Phi_max-Phi_min)/Nphi;
   Angle=[Angle;phi];
   Dphi=(Phi_max-Phi_min)/Nphi;
   if phi==0, Projs=[Projs;sum(INP_IMG)/Sz];
   else 
%         INP_rot=dctrotate(INP_IMG,phi);
        INP_rot=fastrotate(INP_rot,Dphi);
        INP_rot=INP_rot.*Crcl;
        figure(1);
        display1(INP_rot);
        title(['Rotated input image; ',num2str(Sz),'x',num2str(Sz)],'FontWeight','Bold','FontSize',12)
        drawnow
        Projs=[Projs;sum(INP_rot)/Sz];
%         T=etime(clock,t);
%         pause
        figure(2);
        display1(Projs);colormap(jet);
        title(['Sinogram;',num2str(P),'-th projection'],'FontWeight','Bold','FontSize',12);
        drawnow
   end   
end
figure(1);display1(INP_IMG);
title(['Input image; ',num2str(Sz),'x',num2str(Sz)],'FontWeight','Bold','FontSize',12);

% -----------------------------INVERSE RADON TRANSFORM--------------------------

Sz=size(Projs,2);
% X=Sz/2-Sz/4:Sz/2+Sz/4-1;
OUT=zeros(Sz);
% Crcl=circle(Sz);
Nproj=length(Angle);
Fr_mask=pi*(0:fix(Sz/2))/Sz; 
if Sz/2==fix(Sz/2),Fr_mask(Sz/2)=Fr_mask(Sz/2)/2;end 
Fr_mask=[Fr_mask,Fr_mask(ceil(Sz/2):-1:2)];
Fr_mask=kron(Fr_mask,ones(Nproj,1));

sp=fft(Projs').*Fr_mask';
Projs=real((ifft(sp))');
t=clock;
for phi=1:Nproj,
   B_proj=kron(Projs(phi,:),ones(Sz,1)).*Crcl;
    B_proj=fastrotate(B_proj,-Angle(phi));
   figure(3);
   display1(B_proj);
   title(['Rotated filtered back progection; Theta=',num2str(Angle(phi))],'FontWeight','Bold','FontSize',12);
   drawnow
   OUT=OUT+B_proj;
   T=etime(clock,t);
   figure(4);
   display1(srezka(OUT));
   title(['Inv\_radon\_filteredback\_projection; ',num2str(phi),'-th projection'],'FontWeight','Bold','FontSize',12);
   drawnow
end
OUT=srezka(OUT);
% OUT=OUT.*(OUT>=0).*Crcl;
display1(OUT.*(OUT>=0).*Crcl);
title(['Inv\_radon\_filteredback\_projection; ',num2str(phi),'-th projection'],'FontWeight','Bold','FontSize',12);

%-------------------------------------------------------------
function display1(INPIMG)
% Displays a 2-D signal as an image 
% with normalization by gobal maximum and minimum
% Copyright L. Yaroslavsky (yaro@eng.tau.ac.il) 
% Call display1(INPIMG)

clf
colormap(gray(256))
Min=min(min(INPIMG)); Max=max(max(INPIMG));
if Max-Min==0, im=zeros(size(INPIMG)); else im=255*(INPIMG-Min)/(Max-Min); end

image(im);axis image;axis off;
%-----------------------------------------------------------------

%--------------------------------------------------------------------
function figure_n(N)
% Generating N square figure windows of ScreenVerSz/2*ScreenVerSz pixels
% figure('Position',[HorPosition VerPosition HorSize VertSize]);
% Coordinate origin - left bottom corner of the screen
% Version July 15, 2001; Modified Oct. 2008, Tampere
% Copyright L. Yaroslavsky (yaro@eng.tau.ac.il)  
% Call figure_n(N)

% Generating a figure window
ScrSz=get(0,'ScreenSize');
HorSz=(ScrSz(3)-20); VerSz=(ScrSz(4));
% close all;

switch N;
case 1, close all
   Nvert=1;Nhor=1;H_Sz=(HorSz-80); V_Sz=(VerSz-120);
%    figure('Position',[30 VerSz-30-V_Sz V_Sz V_Sz]); colormap(gray(256))
    figure('Position',[80 VerSz-80-V_Sz V_Sz V_Sz]); colormap(gray(256))

case 2, close all 
   Nvert=1;Nhor=2;H_Sz=(HorSz-80)/2; V_Sz=(VerSz-200);
%    figure('Position',[30 VerSz-30-H_Sz H_Sz H_Sz]);colormap(gray(256))
    figure('Position',[30 VerSz-200-H_Sz H_Sz V_Sz]);colormap(gray(256))

%    figure('Position',[30+H_Sz VerSz-30-H_Sz H_Sz H_Sz]);colormap(gray(256))
   figure('Position',[80+H_Sz VerSz-200-H_Sz H_Sz V_Sz]);colormap(gray(256))

case 3,close all 
%    Nvert=2;Nhor=2;H_Sz=(HorSz-80)/2; V_Sz=(VerSz-120)/2;
    Nvert=2;Nhor=2;H_Sz=(HorSz-80)/2; V_Sz=(VerSz-220)/2;
%    figure('Position',[30 VerSz-30-V_Sz H_Sz V_Sz]);colormap(gray(256))
   figure('Position',[30 VerSz-80-V_Sz H_Sz V_Sz]);colormap(gray(256))

%    figure('Position',[30+H_Sz VerSz-30-V_Sz H_Sz V_Sz]);colormap(gray(256))
   figure('Position',[80+H_Sz VerSz-80-V_Sz H_Sz V_Sz]);colormap(gray(256))

%    figure('Position',[30 VerSz-2*V_Sz-75 H_Sz V_Sz]);colormap(gray(256))
   figure('Position',[30 VerSz-2*V_Sz-180 H_Sz V_Sz]);colormap(gray(256))

case 4,close all; 
%    Nvert=2;Nhor=2;H_Sz=(HorSz-80)/2; V_Sz=(VerSz-120)/2;
   Nvert=2;Nhor=2;H_Sz=(HorSz-80)/2; V_Sz=(VerSz-220)/2;
%    figure('Position',[30 VerSz-30-V_Sz H_Sz V_Sz]);colormap(gray(256))
   figure('Position',[30 VerSz-80-V_Sz H_Sz V_Sz]);colormap(gray(256))

%    figure('Position',[30+H_Sz VerSz-30-V_Sz H_Sz V_Sz]);colormap(gray(256))
   figure('Position',[80+H_Sz VerSz-80-V_Sz H_Sz V_Sz]);colormap(gray(256))

%    figure('Position',[30 VerSz-2*V_Sz-75 H_Sz V_Sz]);colormap(gray(256))
   figure('Position',[30 VerSz-2*V_Sz-180 H_Sz V_Sz]);colormap(gray(256))

%    figure('Position',[30+H_Sz VerSz-2*V_Sz-75 H_Sz V_Sz]);colormap(gray(256))
   figure('Position',[80+H_Sz VerSz-2*V_Sz-180 H_Sz V_Sz]);colormap(gray(256))
case 5,
   close all
   Nvert=2;Nhor=3;H_Sz=(HorSz-80)/3; V_Sz=(VerSz-220)/2;
   figure('Position',[30 VerSz-80-V_Sz H_Sz V_Sz]);colormap(gray(256))
   figure('Position',[60+H_Sz VerSz-80-V_Sz H_Sz V_Sz]);colormap(gray(256))
   figure('Position',[85+2*H_Sz VerSz-80-V_Sz H_Sz V_Sz]);colormap(gray(256))
   figure('Position',[30 VerSz-2*V_Sz-180 H_Sz V_Sz]);colormap(gray(256))
   figure('Position',[60+H_Sz VerSz-2*V_Sz-180 H_Sz V_Sz]);colormap(gray(256))
case 6, 
   close all
   Nvert=2;Nhor=3;H_Sz=(HorSz-80)/3; V_Sz=(VerSz-220)/2;
   figure('Position',[30 VerSz-80-V_Sz H_Sz V_Sz]);colormap(gray(256))
   figure('Position',[60+H_Sz VerSz-80-V_Sz H_Sz V_Sz]);colormap(gray(256))
   figure('Position',[85+2*H_Sz VerSz-80-V_Sz H_Sz V_Sz]);colormap(gray(256))
   figure('Position',[30 VerSz-2*V_Sz-180 H_Sz V_Sz]);colormap(gray(256))
   figure('Position',[60+H_Sz VerSz-2*V_Sz-180 H_Sz V_Sz]);colormap(gray(256))
   figure('Position',[80+2*H_Sz VerSz-180-2*V_Sz H_Sz V_Sz]);colormap(gray(256))
end
%--------------------------------------------------------------------------------------------------------

%------------------------------------------------------------
function OUTPUT=ringg(IMGSize,Cvert,Chor,Rext,Rint)

% Generating an image of a ring
% Cvert,Chor - coordinates of the ring center;
% Rext,Rint - ring external and internal radii
% Copyright L. Yaroslavsky (yaro@eng.tau.ac.il)  
% Call OUTPUT=ring(IMGSize,Cvert,Chor,Rext,Rint)


RING=zeros(IMGSize);

for x=1:IMGSize,
	for y=1:IMGSize,
		if ((x-Cvert)^2 + (y-Chor)^2)<Rint^2;
		RING(x,y)=0;
		elseif ((x-Cvert)^2 + (y-Chor)^2)>Rext^2;
		RING(x,y)=0;
		else RING(x,y)=255;end
	end
end
%display1(RING)
OUTPUT=RING/max(RING(:));
%-----------------------------------------------------------
function OUTPUT=fastrotate(INPUT,phi);

% 3-step image rotation by shearing (a copy of myrotate.m: display is disabled)
% phi is the rotation angle in grad.
% Rotation center in point (IMsize+1)/2,(Imsize+1)/2).
% Copyright L. Yaroslavsky (yaro@eng.tau.ac.il)  
% Call OUTPUT=fastrotate(INPUT,phi); 


[SzX SzY] =size(INPUT);
phi=pi*phi/180;
OUTPUT=INPUT;

    %FIRST PASS

if phi == 0
  u=0;
else
  u=(1-cos(phi))/sin(phi);
end

for x=1:SzX,

  Ux=u*(x-SzX/2-1/2);
  My=zeros(1,SzY);
  r=1:fix(SzY/2)+1; 
  Wn=i*2*pi*Ux/SzY;
  My(r)=exp(Wn*(r-1)); 
  My(SzY:-1:fix(SzY/2)+2)=conj(My(2:fix((SzY+1)/2)));  
  spinput=fftnorm(INPUT(x,:));
  spinput=spinput.*My;
  if SzY/2==fix(SzY/2),spinput=[spinput(1:SzY/2) real(spinput(SzY/2+1)) spinput(SzY/2+2:SzY)];end
  OUTPUT(x,:)=real(ifftnorm(spinput));
end

% SECOND PASS

u=-sin(phi);

for y=1:SzY,
  
  Uy=u*(y-SzY/2-1/2);
  Mx=zeros(SzY,1);
  r=1:fix(SzX/2)+1; 
  Wn=i*2*pi*Uy/SzX;
  Mx(r)=exp(Wn*(r-1)); 
  Mx(SzX:-1:fix(SzX/2)+2)=conj(Mx(2:fix((SzX+1)/2)));
  spinput=fftnorm(OUTPUT(:,y));
  spinput=spinput.*Mx;
  if SzX/2==fix(SzX/2),spinput=[spinput(1:SzX/2);real(spinput(SzX/2+1));spinput(SzX/2+2:SzX)];end
  OUTPUT(:,y)=real(ifftnorm(spinput));

end

% THIRD PASS
if phi == 0
  u = 0;
else
  u=(1-cos(phi))/sin(phi);
end

for x=1:SzX,

  Ux=u*(x-SzX/2-1/2);
  My=zeros(1,SzY);
  r=1:fix(SzY/2+1); Wn=i*2*pi*Ux/SzY;
  My(r)=exp(Wn*(r-1)); 
  My(SzY:-1:fix(SzY/2)+2)=conj(My(2:fix((SzY+1)/2)));
  spinput=fftnorm(OUTPUT(x,:));
  spinput=spinput.*My;
  if SzY/2==fix(SzY/2),OUTPUT(x,:)=real(ifftnorm([spinput(1:SzY/2) real(spinput(SzY/2+1)) spinput(SzY/2+2:SzY)]));end
  OUTPUT(x,:)=real(ifftnorm(spinput));
  
end
%-----------------------------------------------------------------------------
function z=fftnorm(signal);

% Normalized direct 1-D FFT
% Copyright L. Yaroslavsky (yaro@eng.tau.ac.il)
% Callz=fftnorm(signal);

N=sqrt(size(signal,2));
signal=signal/N;
z=fft(signal);
%-------------------------------------------------------------
function z=ifftnorm(signal);

% Normalized inverse 1D FFT
% Copyright L. Yaroslavsky (yaro@eng.tau.ac.il)
% Call z=ifftnorm(signal);

N=sqrt(size(signal,2));
signal=signal*N;
z=ifft(signal);
%----------------------------------------------------------------
function OUTIMG=srezka(INPIMG);

% Image normalization by zeroing all pixels that are less then 0
% and assigning 255 to all pixels than exceed 255
% Copyright L. Yaroslavsky (yaro@eng.tau.ac.il)  
% Call OUTIMG=srezka(INPIMG);

OUTIMG=(INPIMG>0).*INPIMG;
OUTIMG=(OUTIMG<=255).*OUTIMG+255*(OUTIMG>255);
%---------------------------------------------------
